## fwupdate 0.4

=== Makefile ===
TOPDIR=$(shell pwd)
include $(TOPDIR)/Make.version
SUBDIRS = efi linux docs

all clean install :
	@set -e ; for x in $(SUBDIRS) ; do \
		$(MAKE) DESTDIR=$(DESTDIR) TOPDIR=$(TOPDIR) VERSION=$(VERSION) \
			LIBDIR=$(LIBDIR) bindir=$(bindir) mandir=$(mandir) \
			-C $$x $@ ; \
	done

fwupdate.spec : fwupdate.spec.in Makefile
	@sed -e "s,@@VERSION@@,$(VERSION),g" $< > $@

GITTAG = $(VERSION)

test-archive: fwupdate.spec
	@rm -rf /tmp/fwupdate-$(VERSION) /tmp/fwupdate-$(VERSION)-tmp
	@mkdir -p /tmp/fwupdate-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/fwupdate-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/fwupdate-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/fwupdate-$(VERSION)-tmp/ /tmp/fwupdate-$(VERSION)/
	@cp fwupdate.spec /tmp/fwupdate-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/fwupdate-$(VERSION).tar.bz2 fwupdate-$(VERSION)
	@rm -rf /tmp/fwupdate-$(VERSION)
	@echo "The archive is in fwupdate-$(VERSION).tar.bz2"

tag:
	git tag -s $(GITTAG) refs/heads/master

archive: tag fwupdate.spec
	@rm -rf /tmp/fwupdate-$(VERSION) /tmp/fwupdate-$(VERSION)-tmp
	@mkdir -p /tmp/fwupdate-$(VERSION)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/fwupdate-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/fwupdate-$(VERSION)-tmp/ /tmp/fwupdate-$(VERSION)/
	@cp fwupdate.spec /tmp/fwupdate-$(VERSION)/
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/fwupdate-$(VERSION).tar.bz2 fwupdate-$(VERSION)
	@rm -rf /tmp/fwupdate-$(VERSION)
	@echo "The archive is in fwupdate-$(VERSION).tar.bz2"

include $(TOPDIR)/Make.defaults

=== efi/Makefile ===
TOPDIR	?= $(shell pwd)/..
include $(TOPDIR)/Make.version
include $(TOPDIR)/Make.defaults


CFLAGS		= -O0 -g3
BUILDFLAGS	:= $(CFLAGS) -fpic -Wall -fshort-wchar \
	-fno-strict-aliasing -fno-merge-constants -ffreestanding \
	-fno-stack-protector -fno-stack-check --std=c11 -DCONFIG_$(ARCH) \
	-D__KERNEL__ -I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
	-iquote$(TOPDIR)/include
LDFLAGS		= -nostdlib --warn-common --no-undefined --fatal-warnings \
	-shared -Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) \
	$(GNUEFIDIR)/crt0-efi-$(ARCH).o

ifeq ($(ARCH),x86_64)
	FORMAT = --target efi-app-$(ARCH)
	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		-maccumulate-outgoing-args -DEFI_FUNCTION_WRAPPER \
		-DGNU_EFI_USE_MS_ABI -I$(shell $(CC) -print-file-name=include)
endif
ifeq ($(ARCH),ia32)
	FORMAT = --target efi-app-$(ARCH)
	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		-maccumulate-outgoing-args -m32 \
		-I$(shell $(CC) -print-file-name=include)
endif

ifeq ($(ARCH),aarch64)
	FORMAT = -O binary
	LDFLAGS += --defsym=EFI_SUBSYSTEM=0xa
	BUILDFLAGS += -ffreestanding -I$(shell $(CC) -print-file-name=include)
endif

ifeq ($(ARCH),arm)
	FORMAT = -O binary
	LDFLAGS += --defsym=EFI_SUBSYSTEM=0xa
	BUILDFLAGS += -ffreestanding -I$(shell $(CC) -print-file-name=include)
endif

MAME=make

TARGETS = fakeesrt2.efi fakeesrt.efi dumpesrt.efi fwupdate.efi mkvar.efi dumpf.efi mkvar2.efi

all : $(TARGETS)

%.efi : %.efi.unsigned
	pesign -s -i $< -o $@ --force -c 'Red Hat Test Certificate'

%.efi.unsigned : %.so
	$(OBJCOPY) -j .text -j .sdata -j .data -j .dynamic -j .dynsym \
		-j .rel* -j .rela* -j .reloc \
		$(FORMAT) $^ $@

%.so : %.o
	$(LD) $(LDFLAGS) -o $@ $^ -lefi -lgnuefi \
		$(shell gcc -print-libgcc-file-name) \
		-T $(GNUEFIDIR)/elf_$(ARCH)_efi.lds

%.o : %.c
	$(CC) $(BUILDFLAGS) -c -o $@ $^

clean :
	@rm -vf $(TARGETS) *.o *.so *.efi.unsigned *.efi

install : fwupdate.efi
	$(INSTALL) -d -m 755 $(DESTDIR)/boot/efi/EFI/$(EFIDIR)/fw/
	$(INSTALL) -m 755 fwupdate.efi $(DESTDIR)/boot/efi/EFI/$(EFIDIR)/fwupdate.efi

=== linux/Makefile ===
TOPDIR	?= $(shell pwd)/..
include $(TOPDIR)/Make.version
include $(TOPDIR)/Make.defaults

LIB_LIBS= pthread
BIN_LIBS= popt pthread
PKLIBS	= efivar efiboot
CFLAGS	= -g -O0
PJONES  =
BIN_CCLDFLAGS = $(foreach lib,$(BIN_LIBS),-l$(lib)) \
	$(foreach pklib,$(PKLIBS), \
		$(shell pkg-config --libs-only-l --libs-only-other $(pklib))) \
	-pie -fPIE -Wl,-z,relro,-z,now -L.
LIB_CCLDFLAGS = $(foreach lib,$(LIB_LIBS),-l$(lib)) \
	$(foreach pklib,$(PKLIBS), \
		$(shell pkg-config --libs-only-l --libs-only-other $(pklib))) \
	-shared -fPIC -Wl,-z,relro,-z,now

BUILDFLAGS := $(CFLAGS) -Wall -Wno-unused-result -Wno-unused-function \
	-Wsign-compare -Werror=sign-compare \
	-fshort-wchar --std=c11 \
	-DLOCALEDIR=\"$(localedir)\" -D_GNU_SOURCE \
	-DFWUP_EFI_DIR_NAME=\"$(EFIDIR)\"  \
	-I$(TOPDIR)/linux/include -iquote$(TOPDIR)/include/ \
	$(foreach pklib,$(PKLIBS), $(shell pkg-config --cflags $(pklib))) \
	$(PJONES)

BINTARGETS=fwupdate
INCTARGETS=include/fwup.h
LIBTARGETS=libfwup.so.$(VERSION)
PCTARGETS=fwup.pc
POTARGETS = fwupdate.po libfwup.po
TARGETS=$(BINTARGETS) $(INCTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) libfwup.so

.SUFFIXES:

all : $(TARGETS)

fwupdate : libfwup.so

% : %.o
	$(CC) $(BUILDFLAGS) $(BIN_CCLDFLAGS) -o $@ $(patsubst lib%.so,-l%,$^)

%.so.$(VERSION) : %.o
	$(CC) $(BUILDFLAGS) $(LIB_CCLDFLAGS) \
		-Wl,-soname,$@ \
		-o $@ $^

%.so : %.so.$(VERSION)
	ln -sf $^ $@

%.po : %.c
	$(XGETTEXT) -a --package-name=$(patsubst %.po,%,$@) --package-version=$(VERSION) -o $@ $^

%.o : %.c
	$(CC) $(BUILDFLAGS) -fPIC -c -o $@ $^

fwup.pc : fwup.pc.in
	sed -e "s,@@VERSION@@,$(VERSION),g" \
		-e "s,@@LIBDIR@@,$(libdir),g" \
		$< > $@

tester : tester.c
	$(CC) -Wall -Werror -ggdb -L. -I./include -I/usr/include/efivar \
		-lefivar -lfwup -o $@ $^

test : tester
	LD_LIBRARY_PATH=$(shell pwd) ./tester

clean :
	@rm -vf $(BINTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) *.o

install : all
	$(INSTALL) -d -m 755 $(DESTDIR)/$(libdir)
	$(foreach x, $(LIBTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(libdir);)
	$(INSTALL) -d -m 755 $(DESTDIR)/$(pcdir)
	$(foreach x, $(PCTARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(pcdir) ;)
	$(INSTALL) -d -m 755 $(DESTDIR)/$(includedir)/
	$(INSTALL) -m 644 $(INCTARGETS) $(DESTDIR)/$(includedir)/
	$(INSTALL) -d -m 755 $(DESTDIR)/$(localedir)/en/
	$(INSTALL) -m 644 $(POTARGETS) $(DESTDIR)/$(localedir)/en/
	$(INSTALL) -d -m 755 $(DESTDIR)/$(bindir)
	$(foreach x, $(BINTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(bindir);)
	ln -sf libfwup.so.$(VERSION) $(DESTDIR)/$(libdir)/libfwup.so
	$(foreach x, $(wildcard *.so.$(VERSION)), ln -fs $(x) $(patsubst %.so.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x));)

=== debian/changelog ===
fwupdate (0.4-4ubuntu2) wily; urgency=medium

  * debian/patches/sbsigntool-not-pesign: dropped.
  * debian/patches/do-not-pesign: don't self-sign EFI binaries.
  * debian/control: dropped Build-Depends on pesign.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 18 Sep 2015 16:48:21 -0400

fwupdate (0.4-4ubuntu1) wily; urgency=medium

  * debian/patches/sbsigntool-not-pesign: use sbsigntool rather than pesign to
    do the initial self-signing.
  * debian/control:
    - don't build-depend on pesign; we use sbsigntool instead.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Fri, 18 Sep 2015 16:17:59 -0400

fwupdate (0.4-4) unstable; urgency=medium

  [ Daniel Jared Dominguez ]
  * Don't depend on efibootmgr since fwupdate uses efivar to set BootNext
  * update VCS info

  [ Mario Limonciello ]
  * Adjust maintainer to be team owned.
  * Backport 05d715f and 448aaab to fix arm* FTBFS. (Closes: #792904)

 -- Mario Limonciello <mario_limonciello@dell.com>  Wed, 09 Sep 2015 10:21:38 -0500

fwupdate (0.4-3) unstable; urgency=medium

  * We need elfutils now.

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Mon, 13 Jul 2015 15:44:47 -0500

fwupdate (0.4-2) unstable; urgency=medium

  [ Mario Limonciello ]
  * For the distribution directory make sure that it's lowercase.
    This is what Debian and Ubuntu use for their EFI directories.
  * Import a patch from upstream to fix linking order when --as-needed.
  * Don't store EFI application in /boot/EFI in debian package.
    This causes upgrade issues for the package.  Move it over to
    /usr/lib/fwupdate and install in the postinst.
  * Add some patches that fix the Boot entry creation GUID.
  [ Daniel Jared Dominguez ]
  * Fix a minor "make install" weirdness with our library symlinks.
  * Add UEFI debugging stuff to the fwupdate binaries. (from upstream)

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Mon, 13 Jul 2015 13:32:42 -0500

fwupdate (0.4-1) unstable; urgency=low

  * Initial release (Closes: #785137)

 -- Daniel Jared Dominguez <Jared_Dominguez@Dell.com>  Mon, 01 Jun 2015 22:30:51 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DH_OPTIONS=-V

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
EFIDIR ?= $(shell lsb_release -is | awk '{ print tolower($$0) }')

buildroot	:= debian/tmp

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- libdir=\$${prefix}/usr/lib/$(DEB_HOST_MULTIARCH) LIBDIR=\$${prefix}/usr/lib GNUEFIDIR=\$${prefix}/usr/lib EFIDIR=$(EFIDIR)


override_dh_auto_install:
	dh_auto_install -- libdir=\$${prefix}/usr/lib/$(DEB_HOST_MULTIARCH) LIBDIR=\$${prefix}/usr/lib GNUEFIDIR=\$${prefix}/usr/lib EFIDIR=$(EFIDIR)
	chmod -x ${buildroot}/boot/efi/EFI/$(EFIDIR)/fwupdate.efi

## fwupdate 0.4+git20151030.114130.df3fd37

=== efi/Makefile ===
--- 
+++ 
@@ -2,16 +2,16 @@
 include $(TOPDIR)/Make.version
 include $(TOPDIR)/Make.defaults
 
-
-CFLAGS		= -O0 -g3
+CFLAGS		?= -O0 -g3
 BUILDFLAGS	:= $(CFLAGS) -fpic -Wall -fshort-wchar \
 	-fno-strict-aliasing -fno-merge-constants -ffreestanding \
 	-fno-stack-protector -fno-stack-check --std=c11 -DCONFIG_$(ARCH) \
 	-D__KERNEL__ -I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
-	-iquote$(TOPDIR)/include
-LDFLAGS		= -nostdlib --warn-common --no-undefined --fatal-warnings \
-	-shared -Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) \
+	-iquote$(TOPDIR)/include "-DDEBUGDIR=L\"$(DEBUGDIR)/\""
+LDFLAGS		?= -nostdlib --warn-common --no-undefined --fatal-warnings \
+	-shared -Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) --build-id=sha1 \
 	$(GNUEFIDIR)/crt0-efi-$(ARCH).o
+OBJCOPY_GTE224 = $(shell expr `$(OBJCOPY) --version |grep ^"GNU objcopy" | sed 's/^.* //g' | cut -f1-2 -d.` \>= 2.24)
 
 ifeq ($(ARCH),x86_64)
 	FORMAT = --target efi-app-$(ARCH)
@@ -44,25 +44,57 @@
 
 all : $(TARGETS)
 
-%.efi : %.efi.unsigned
+.SECONDARY: $(foreach target,$(TARGETS),$(target).debug $(target).build-id)
+
+%.efi : %.efi.unsigned %.efi.debug %.efi.build-id
 	pesign -s -i $< -o $@ --force -c 'Red Hat Test Certificate'
 
 %.efi.unsigned : %.so
+ifneq ($(OBJCOPY_GTE224),1)
+	$(error objcopy >= 2.24 is required)
+endif
 	$(OBJCOPY) -j .text -j .sdata -j .data -j .dynamic -j .dynsym \
-		-j .rel* -j .rela* -j .reloc \
+		-j .rel* -j .rela* -j .reloc -j .eh_frame \
 		$(FORMAT) $^ $@
+
+%.efi.debug : %.so
+ifneq ($(OBJCOPY_GTE224),1)
+	$(error objcopy >= 2.24 is required)
+endif
+	$(OBJCOPY) -j .text -j .sdata -j .data -j .dynamic -j .dynsym \
+		-j .rel* -j .rela* -j .reloc -j .eh_frame \
+		-j .debug* -j .note.gnu.build-id \
+		$^ $@
+
+%.efi.build-id : %.so
+	$(READELF) -n $^ | grep "Build ID:" | \
+		sed -e 's/^.*Build ID: //' -e 's,^\(..\),\1/,' > $@
 
 %.so : %.o
 	$(LD) $(LDFLAGS) -o $@ $^ -lefi -lgnuefi \
-		$(shell gcc -print-libgcc-file-name) \
-		-T $(GNUEFIDIR)/elf_$(ARCH)_efi.lds
+		$(shell $(CC) -print-libgcc-file-name) \
+		-T elf_$(ARCH)_efi.lds
 
 %.o : %.c
 	$(CC) $(BUILDFLAGS) -c -o $@ $^
 
 clean :
-	@rm -vf $(TARGETS) *.o *.so *.efi.unsigned *.efi
+	@rm -vf $(TARGETS) *.o *.so *.efi.unsigned *.efi *.efi.debug \
+		*.efi.build-id
+
+buildiddir = $(dirname $(shell cat $(1).build-id))
+define inst =
+ $(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)
+ $(INSTALL) -m 755 $(1) $(DESTDIR)$(TARGETDIR)$(1)
+ $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO)$(TARGETDIR)
+ $(INSTALL) -m 755 $(1).debug $(DESTDIR)$(DEBUGINFO)$(TARGETDIR)/$(1).debug
+ $(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGINFO).build-id/$(dir $(shell cat $(1).build-id))
+ ln -sf ../../../../..$(TARGETDIR)$(1) $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id)
+ ln -sf ../..$(TARGETDIR)$(1).debug $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id).debug
+endef
 
 install : fwupdate.efi
-	$(INSTALL) -d -m 755 $(DESTDIR)/boot/efi/EFI/$(EFIDIR)/fw/
-	$(INSTALL) -m 755 fwupdate.efi $(DESTDIR)/boot/efi/EFI/$(EFIDIR)/fwupdate.efi
+	$(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)/fw/
+	$(foreach prog,$^,$(call inst,$(prog)) ; )
+	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/efi
+	$(foreach src,$(wildcard *.[chS]),$(INSTALL) -m 644 $(src) $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/efi/$(src) ;)

=== linux/Makefile ===
--- 
+++ 
@@ -5,16 +5,16 @@
 LIB_LIBS= pthread
 BIN_LIBS= popt pthread
 PKLIBS	= efivar efiboot
-CFLAGS	= -g -O0
+CFLAGS	?= -g -O0
 PJONES  =
 BIN_CCLDFLAGS = $(foreach lib,$(BIN_LIBS),-l$(lib)) \
 	$(foreach pklib,$(PKLIBS), \
 		$(shell pkg-config --libs-only-l --libs-only-other $(pklib))) \
-	-pie -fPIE -Wl,-z,relro,-z,now -L.
+	$(LDFLAGS) -pie -fPIE -Wl,-z,relro,-z,now -L.
 LIB_CCLDFLAGS = $(foreach lib,$(LIB_LIBS),-l$(lib)) \
 	$(foreach pklib,$(PKLIBS), \
 		$(shell pkg-config --libs-only-l --libs-only-other $(pklib))) \
-	-shared -fPIC -Wl,-z,relro,-z,now
+	$(LDFLAGS) -shared -fPIC -Wl,-z,relro,-z,now
 
 BUILDFLAGS := $(CFLAGS) -Wall -Wno-unused-result -Wno-unused-function \
 	-Wsign-compare -Werror=sign-compare \
@@ -27,7 +27,7 @@
 
 BINTARGETS=fwupdate
 INCTARGETS=include/fwup.h
-LIBTARGETS=libfwup.so.$(VERSION)
+LIBTARGETS=libfwup.so.$(VERSION) libfwup.so.$(MAJOR_VERSION)
 PCTARGETS=fwup.pc
 POTARGETS = fwupdate.po libfwup.po
 TARGETS=$(BINTARGETS) $(INCTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) libfwup.so
@@ -39,15 +39,18 @@
 fwupdate : libfwup.so
 
 % : %.o
-	$(CC) $(BUILDFLAGS) $(BIN_CCLDFLAGS) -o $@ $(patsubst lib%.so,-l%,$^)
+	$(CC) $(BUILDFLAGS) -o $@ $(patsubst lib%.so,-l%,$^) $(BIN_CCLDFLAGS)
 
 %.so.$(VERSION) : %.o
-	$(CC) $(BUILDFLAGS) $(LIB_CCLDFLAGS) \
-		-Wl,-soname,$@ \
-		-o $@ $^
+	$(CC) $(BUILDFLAGS) \
+		-Wl,-soname,$(patsubst %.o,%.so.$(MAJOR_VERSION),$<) \
+		-o $@ $^ $(LIB_CCLDFLAGS)
+
+%.so.$(MAJOR_VERSION) : %.so.$(VERSION)
+	ln -sf $< $@
 
 %.so : %.so.$(VERSION)
-	ln -sf $^ $@
+	ln -sf $< $@
 
 %.po : %.c
 	$(XGETTEXT) -a --package-name=$(patsubst %.po,%,$@) --package-version=$(VERSION) -o $@ $^
@@ -69,6 +72,7 @@
 
 clean :
 	@rm -vf $(BINTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) *.o
+	@rm -vf libfwup.so*
 
 install : all
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(libdir)
@@ -81,5 +85,4 @@
 	$(INSTALL) -m 644 $(POTARGETS) $(DESTDIR)/$(localedir)/en/
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(bindir)
 	$(foreach x, $(BINTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(bindir);)
-	ln -sf libfwup.so.$(VERSION) $(DESTDIR)/$(libdir)/libfwup.so
-	$(foreach x, $(wildcard *.so.$(VERSION)), ln -fs $(x) $(patsubst %.so.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x));)
+	$(foreach x, $(wildcard *.so.$(VERSION)), ln -fs $(x) $(patsubst %.so.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x)); ln -fs $(x) $(patsubst %.so.$(VERSION),%.so.$(MAJOR_VERSION),$(DESTDIR)/$(libdir)/$(x));)

=== debian/changelog ===
fwupdate (0.4+git20151030.114130.df3fd37-0ubuntu1~15.04.1) vivid; urgency=medium

  * Hardware enablement backport to 15.04. (LP: #1512518)

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 02 Nov 2015 17:10:18 -0600

fwupdate (0.4+git20151030.114130.df3fd37-0ubuntu1) xenial; urgency=medium

  * New upstream snapshot:
    - Don't ignore the invalid protective MBR
    - Fix firmware update failure due to not finding capsule image
    - Smartly match up the device path for capsule image
  * debian/patches/open_modes.patch: dropped, applied upstream.
  * debian/patches/link_with_cc.patch: update to properly build time binary
    by using --hash-style=sysv so we get the right type of hash table for
    symbols.
  * debian/patches/find_shim.patch: find the right path for shim in the ESP
    when we go to add the entry for the firmware updater.
  * debian/patches/firmware_updater_name.patch: drop spaces in Linux Firmware
    Updater name when creating the BootEntry: shim parses them and gets
    confused.
  * debian/rules: build an extra artefact for EFI binaries for signing.
  * debian/fwupdate.{postinst,postrm}: Don't install fwupdate.efi to the ESP.
  * debian/rules: don't try to chmod fwupdate.efi in the ESP, since we don't
    ship it.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 02 Nov 2015 12:16:59 -0500

fwupdate (0.4+git20151015.081427-0ubuntu3) xenial; urgency=medium

  * debian/patches/link_with_cc.patch: really fix armhf and arm64: pass the
    upstream LDFLAGS via CCLDFLAGS; so that these architectures get the right
    options while building and linking. This is basically upstream commit
    9c1517d1.
  * debian/patches/open_modes.patch: pass mode 0600 rather than 0 for open,
    even if the mode might not be that meaningful to FAT. (d9981cd5)

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 26 Oct 2015 15:21:53 -0400

fwupdate (0.4+git20151015.081427-0ubuntu2) xenial; urgency=medium

  * debian/patches/link_with_cc.patch: also update LDFLAGS additions for arm
    and aarch64 (setting --defsym) to be properly parsed by CC as LD options.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Mon, 26 Oct 2015 14:23:49 -0400

fwupdate (0.4+git20151015.081427-0ubuntu1) xenial; urgency=medium

  * Upstream snapshot 2015-10-15 08:14:27 (3a0452b4)
    - Clear time_attempted for the existing status info
    - Fix returning NULL path if status variable contains an existing capsule
    - Do not close() the fd passed to fwup_set_up_update()
    - Don't show an error if SHIM_DEBUG isn't found.
    - Respect CFLAGS and LDFLAGS
    - Be more resilient against malformed status variables.
    - Add missing armv7 .lds
    - Use the correct GUID when setting Boot#### entries.
    - Do a better job of setting SONAME right.
  * debian/patches/000*: Removed patches (applied upstream):
    - 0001-Do-a-better-job-of-setting-SONAME-right.patch
    - 0002-In-clean-rule-remove-libfwup.so.patch
    - 0003-Reorder-parameters-to-gcc-so-things-link-correctly.patch
    - 0004-Fix-another-place-where-we-should-be-using-efi_guid_.patch
    - 0005-Use-the-correct-GUID-when-setting-Boot-entries.patch
    - 0006-Fix-a-minor-make-install-weirdness-with-our-library-.patch
    - 0007-Add-UEFI-debugging-stuff-to-the-fwupdate-binaries.patch
    - 0008-Add-missing-armv7-.lds.patch
    - 0009-Explicitly-place-our-build-id-notes.patch
  * debian/patches/link_with_cc.patch: use $(CC) to link instead of $(LD),
    since we pass default flags with -Wl.
  * debian/patches/open_modes.patch: open() needs a third option if used with
    O_CREAT, for file mode.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 22 Oct 2015 18:17:18 +0100

=== debian/control ===
Source: fwupdate
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian EFI <debian-efi@lists.debian.org>
Uploaders: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>, Steve McIntyre <93sam@debian.org>
Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 0.16), lsb-release, gnu-efi (>= 3.0.2), elfutils
Standards-Version: 3.9.6.1
Section: libs
Homepage: https://github.com/rhinstaller/fwupdate
Vcs-Git: git://anonscm.debian.org/uefi/fwupdate.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=uefi/fwupdate.git

Package: libfwup-dev
Section: libdevel
Architecture: amd64 i386 armhf arm64 armel
Multi-Arch: same
Depends: libfwup0 (= ${binary:Version}), ${misc:Depends}, libefivar-dev (>= 0.16)
Description: Development headers for linfwup
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This package provides development headers required to use libfwup.

Package: fwupdate
Section: admin
Architecture: amd64 i386 armhf arm64 armel
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup0 (= ${binary:Version})
Description: Tools to manage UEFI firmware updates
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This package provides a simple command line interface to perform UEFI 
 firmware updates.

Package: libfwup0
Architecture: amd64 i386 armhf arm64 armel
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI firmware updates
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This library is to allow for the simple manipulation of UEFI firmware updates.

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,8 @@
 
 export DH_VERBOSE=1
 export DH_OPTIONS=-V
+
+deb_version             := $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 EFIDIR ?= $(shell lsb_release -is | awk '{ print tolower($$0) }')
@@ -18,4 +20,19 @@
 
 override_dh_auto_install:
 	dh_auto_install -- libdir=\$${prefix}/usr/lib/$(DEB_HOST_MULTIARCH) LIBDIR=\$${prefix}/usr/lib GNUEFIDIR=\$${prefix}/usr/lib EFIDIR=$(EFIDIR)
-	chmod -x ${buildroot}/boot/efi/EFI/$(EFIDIR)/fwupdate.efi
+
+override_dh_clean:
+	dh_clean
+	rm -rf debian/fwupdate-images
+
+TARNAME := fwupdate_$(deb_version)_$(DEB_HOST_ARCH).tar.gz
+
+override_dh_builddeb:
+	dh_builddeb -- -Zxz
+	mkdir -p debian/fwupdate-images/$(deb_version)
+	cp efi/fwupdate.efi debian/fwupdate-images/$(deb_version)
+	echo $(deb_version) \
+                > debian/fwupdate-images/$(deb_version)/version
+	cd debian/fwupdate-images && tar czvf ../../../$(TARNAME) .
+	dpkg-distaddfile $(TARNAME) raw-uefi -
+

## fwupdate 0.5

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 TOPDIR=$(shell pwd)
 include $(TOPDIR)/Make.version
-SUBDIRS = efi linux docs
+include $(TOPDIR)/Make.defaults
+SUBDIRS = efi linux docs include
 
 all clean install :
 	@set -e ; for x in $(SUBDIRS) ; do \
@@ -37,5 +38,3 @@
 	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/fwupdate-$(VERSION).tar.bz2 fwupdate-$(VERSION)
 	@rm -rf /tmp/fwupdate-$(VERSION)
 	@echo "The archive is in fwupdate-$(VERSION).tar.bz2"
-
-include $(TOPDIR)/Make.defaults

=== docs/Makefile ===
SRCDIR = .
TOPDIR = $(SRCDIR)/..

include $(TOPDIR)/Make.defaults

MAN1TARGETS = fwupdate.1
MAN3TARGETS = libfwup.h.3 \
	      libfwup.3 \
	      fwup_supported.3 \
	      fwup_resource_iter_next.3 \
	      fwup_resource_iter_create.3 \
	      fwup_resource_iter_destroy.3 \
	      fwup_set_up_update.3 \
	      fwup_clear_status.3 \
	      fwup_get_guid.3 \
	      fwup_get_fw_version.3 \
	      fwup_get_lowest_supported_version.3 \
	      fwup_get_last_attempt_info.3

all :

clean :

test :

install :
	$(INSTALL) -d -m 755 $(DESTDIR)/$(mandir)/man1
	$(foreach x, $(MAN1TARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(mandir)/man1/;)
	$(INSTALL) -d -m 755 $(DESTDIR)/$(mandir)/man3
	$(foreach x, $(MAN3TARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(mandir)/man3/;)

.PHONY: all clean test install

=== efi/Makefile ===
--- 
+++ 
@@ -6,50 +6,61 @@
 BUILDFLAGS	:= $(CFLAGS) -fpic -Wall -fshort-wchar \
 	-fno-strict-aliasing -fno-merge-constants -ffreestanding \
 	-fno-stack-protector -fno-stack-check --std=c11 -DCONFIG_$(ARCH) \
-	-D__KERNEL__ -I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
+	-I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
 	-iquote$(TOPDIR)/include "-DDEBUGDIR=L\"$(DEBUGDIR)/\""
-LDFLAGS		?= -nostdlib --warn-common --no-undefined --fatal-warnings \
-	-shared -Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) --build-id=sha1 \
+CCLDFLAGS	?= -nostdlib -Wl,--warn-common \
+	-Wl,--no-undefined -Wl,--fatal-warnings \
+	-Wl,-shared -Wl,-Bsymbolic -L$(LIBDIR) -L$(GNUEFIDIR) \
+	-Wl,--build-id=sha1 -Wl,--hash-style=sysv \
 	$(GNUEFIDIR)/crt0-efi-$(ARCH).o
 OBJCOPY_GTE224 = $(shell expr `$(OBJCOPY) --version |grep ^"GNU objcopy" | sed 's/^.* //g' | cut -f1-2 -d.` \>= 2.24)
+
+FWUP = fwupdate
 
 ifeq ($(ARCH),x86_64)
 	FORMAT = --target efi-app-$(ARCH)
 	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
 		-maccumulate-outgoing-args -DEFI_FUNCTION_WRAPPER \
 		-DGNU_EFI_USE_MS_ABI -I$(shell $(CC) -print-file-name=include)
+	FWUP = fwupx64
 endif
 ifeq ($(ARCH),ia32)
 	FORMAT = --target efi-app-$(ARCH)
 	BUILDFLAGS += -mno-mmx -mno-sse -mno-red-zone -nostdinc \
 		-maccumulate-outgoing-args -m32 \
 		-I$(shell $(CC) -print-file-name=include)
+	FWUP = fwupia32
 endif
 
 ifeq ($(ARCH),aarch64)
 	FORMAT = -O binary
-	LDFLAGS += --defsym=EFI_SUBSYSTEM=0xa
+	CCLDFLAGS += -Wl,--defsym=EFI_SUBSYSTEM=0xa
 	BUILDFLAGS += -ffreestanding -I$(shell $(CC) -print-file-name=include)
+	FWUP = fwupaa64
 endif
 
 ifeq ($(ARCH),arm)
 	FORMAT = -O binary
-	LDFLAGS += --defsym=EFI_SUBSYSTEM=0xa
+	CCLDFLAGS += -Wl,--defsym=EFI_SUBSYSTEM=0xa
 	BUILDFLAGS += -ffreestanding -I$(shell $(CC) -print-file-name=include)
+	FWUP = fwuparm
 endif
 
-MAME=make
-
-TARGETS = fakeesrt2.efi fakeesrt.efi dumpesrt.efi fwupdate.efi mkvar.efi dumpf.efi mkvar2.efi
+TARGETS = fakeesrt2.efi fakeesrt.efi dumpesrt.efi $(FWUP).efi mkvar.efi dumpf.efi mkvar2.efi
 
 all : $(TARGETS)
 
 .SECONDARY: $(foreach target,$(TARGETS),$(target).debug $(target).build-id)
 
-%.efi : %.efi.unsigned %.efi.debug %.efi.build-id
+$(FWUP).so : fwupdate.so
+	ln -f $< $@
+
+$(FWUP).efi : | $(FWUP).so
+
+%.efi.signed : %.efi %.efi.debug %.efi.build-id
 	pesign -s -i $< -o $@ --force -c 'Red Hat Test Certificate'
 
-%.efi.unsigned : %.so
+%.efi : %.so
 ifneq ($(OBJCOPY_GTE224),1)
 	$(error objcopy >= 2.24 is required)
 endif
@@ -71,7 +82,7 @@
 		sed -e 's/^.*Build ID: //' -e 's,^\(..\),\1/,' > $@
 
 %.so : %.o
-	$(LD) $(LDFLAGS) -o $@ $^ -lefi -lgnuefi \
+	$(CC) $(CCLDFLAGS) -o $@ $^ -lefi -lgnuefi \
 		$(shell $(CC) -print-libgcc-file-name) \
 		-T elf_$(ARCH)_efi.lds
 
@@ -79,7 +90,7 @@
 	$(CC) $(BUILDFLAGS) -c -o $@ $^
 
 clean :
-	@rm -vf $(TARGETS) *.o *.so *.efi.unsigned *.efi *.efi.debug \
+	@rm -vf $(TARGETS) *.o *.so *.efi.signed *.efi *.efi.debug \
 		*.efi.build-id
 
 buildiddir = $(dirname $(shell cat $(1).build-id))
@@ -93,7 +104,7 @@
  ln -sf ../..$(TARGETDIR)$(1).debug $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id).debug
 endef
 
-install : fwupdate.efi
+install : $(FWUP).efi | $(FWUP).efi.debug $(FWUP).efi.build-id
 	$(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)/fw/
 	$(foreach prog,$^,$(call inst,$(prog)) ; )
 	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/efi

=== include/Makefile ===
TOPDIR	?= $(shell pwd)/..
include $(TOPDIR)/Make.version
include $(TOPDIR)/Make.defaults

all clean :

install :
	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/include
	$(foreach src,$(wildcard *.[chS]),$(INSTALL) -m 644 $(src) $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/include/$(src) ;)

=== linux/Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 
 BUILDFLAGS := $(CFLAGS) -Wall -Wno-unused-result -Wno-unused-function \
 	-Wsign-compare -Werror=sign-compare \
-	-fshort-wchar --std=c11 \
+	-fshort-wchar --std=gnu11 \
 	-DLOCALEDIR=\"$(localedir)\" -D_GNU_SOURCE \
 	-DFWUP_EFI_DIR_NAME=\"$(EFIDIR)\"  \
 	-I$(TOPDIR)/linux/include -iquote$(TOPDIR)/include/ \
@@ -30,7 +30,7 @@
 LIBTARGETS=libfwup.so.$(VERSION) libfwup.so.$(MAJOR_VERSION)
 PCTARGETS=fwup.pc
 POTARGETS = fwupdate.po libfwup.po
-TARGETS=$(BINTARGETS) $(INCTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) libfwup.so
+TARGETS=$(BINTARGETS) $(INCTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) libfwup.so cleanup.service cleanup
 
 .SUFFIXES:
 
@@ -58,9 +58,12 @@
 %.o : %.c
 	$(CC) $(BUILDFLAGS) -fPIC -c -o $@ $^
 
-fwup.pc : fwup.pc.in
+% : %.in
 	sed -e "s,@@VERSION@@,$(VERSION),g" \
+		-e "s,@@DATADIR@@,$(datadir),g" \
+		-e "s,@@EFIDIR@@,$(EFIDIR),g" \
 		-e "s,@@LIBDIR@@,$(libdir),g" \
+		-e "s,@@LIBEXECDIR@@,$(libexecdir),g" \
 		$< > $@
 
 tester : tester.c
@@ -73,6 +76,7 @@
 clean :
 	@rm -vf $(BINTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) *.o
 	@rm -vf libfwup.so*
+	@rm -vf cleanup.service cleanup
 
 install : all
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(libdir)
@@ -86,3 +90,12 @@
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(bindir)
 	$(foreach x, $(BINTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(bindir);)
 	$(foreach x, $(wildcard *.so.$(VERSION)), ln -fs $(x) $(patsubst %.so.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x)); ln -fs $(x) $(patsubst %.so.$(VERSION),%.so.$(MAJOR_VERSION),$(DESTDIR)/$(libdir)/$(x));)
+	$(INSTALL) -d -m 755 $(DESTDIR)$(datadir)/fwupdate/
+	$(INSTALL) -d -m 755 $(DESTDIR)$(libexecdir)/fwupdate/
+	$(INSTALL) -m 755 cleanup $(DESTDIR)$(libexecdir)/fwupdate/cleanup
+	$(INSTALL) -d -m 755 $(DESTDIR)$(libdatadir)/systemd/system
+	$(INSTALL) -m 644 cleanup.service \
+		$(DESTDIR)$(libdatadir)/systemd/system/fwupdate-cleanup.service
+	$(INSTALL) -d -m 755 $(DESTDIR)/usr/share/bash-completion/completions/
+	$(INSTALL) -m 755 bash-completion \
+		$(DESTDIR)/usr/share/bash-completion/completions/fwupdate

=== debian/changelog ===
fwupdate (0.5-2ubuntu4) xenial; urgency=medium

  * Build DISTRIBUTOR into /usr/lib/fwupdate/install at build using dpkg-vendor.
  * Modify postrm script:
    - hardcode EFIDIR at build time
    - use DPKG_MAINTSCRIPT_ARCH

 -- Mario Limonciello <mario_limonciello@dell.com>  Sun, 20 Mar 2016 14:12:38 -0500

fwupdate (0.5-2ubuntu3) xenial; urgency=medium

  * If EFI variables aren't available when the postinst runs, don't mistakingly
    mark the cleanup script as done.  This avoids the cleanup done flag being
    written in chroot situations such as building a livefs.
  * Purge EFI binaries from ESP for correct architecture
  * If system isn't running in EFI mode, don't install binary to ESP directory

 -- Mario Limonciello <mario_limonciello@dell.com>  Sun, 20 Mar 2016 02:55:41 -0500

fwupdate (0.5-2ubuntu2) xenial; urgency=medium

  * Remove immutable attribute in cleanup script due to a kernel behavioral
    change in ed8b0de5.
  * Correct one more path related to signed script

 -- Mario Limonciello <mario_limonciello@dell.com>  Thu, 17 Mar 2016 10:33:16 -0500

fwupdate (0.5-2ubuntu1) xenial; urgency=medium

  * Correct the location of the signed binaries

 -- Mario Limonciello <mario_limonciello@dell.com>  Wed, 16 Mar 2016 00:52:15 -0500

fwupdate (0.5-2) unstable; urgency=medium

  * Remove unowned files that were created by fwupdate through purge.
    (Fixes: #810697)

 -- Mario Limonciello <mario_limonciello@dell.com>  Mon, 11 Jan 2016 16:04:19 -0600

fwupdate (0.5-1) unstable; urgency=medium

  * New upstream version: 0.5.
  * Drop all patches merged upstream.
  * debian/rules: Adjust GNUEFIDIR to not include prefix.
  * Adjust name of binary that is installed to ESP
  * Adjust build arguments to changes in build system
  * Add clean file for systemd rules that aren't automatically cleaned on make 
    clean
  * Install systemd clean service script to /usr/lib/fwupdate
  * Install new man pages and systemd service files
  * Add efibootmgr to fwupdate dependencies to allow cleanup from postinst
  * Cleanup Bootnum for old fwupdate.efi.  It will be regenerated with 
    fwupd64.efi
  * Place the done file for the cleanup service in /var/cache
  * Call fwupdate cleanup in postinst to avoid problems with OS reinstallation
  * Install EFI binaries for non-x64 arch as well
  * Remove multiple Linux Firmware Updater entries if they exist
  * Create cache directory in package
  * Don't cleanup extra NVRAM boot entries on postinst.
  * Build a raw-uefi archive for use with UEFI signing
  * Add a common script for instaling fwup*.efi binary to ESP
  * Remove empty postinst and postrm scripts for libfwup0.
  * Only build raw-uefi archive on Ubuntu

 -- Mario Limonciello <mario_limonciello@dell.com>  Thu, 19 Nov 2015 11:48:01 -0600

fwupdate (0.4-5) unstable; urgency=medium

  [ Mathieu Trudel-Lapierre ]
  * debian/patches/do-not-pesign: don't self-sign EFI binaries.
  * debian/control: dropped Build-Depends on pesign.

  [ Mario Limonciello ]
  * Backport 1c7f78 and 1c1218  to avoid errors if SHIM_DEBUG is missing.
  * Add myself to uploaders.

 -- Mario Limonciello <mario_limonciello@dell.com>  Mon, 05 Oct 2015 14:43:51 -0500

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: fwupdate
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian EFI <debian-efi@lists.debian.org>
-Uploaders: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>, Steve McIntyre <93sam@debian.org>
-Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 0.16), lsb-release, gnu-efi (>= 3.0.2), elfutils
+Maintainer: Debian EFI <debian-efi@lists.debian.org>
+Uploaders: Daniel Jared Dominguez <Jared_Dominguez@Dell.com>, Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario_limonciello@dell.com>
+Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 0.16), gnu-efi (>= 3.0.2), elfutils
 Standards-Version: 3.9.6.1
 Section: libs
 Homepage: https://github.com/rhinstaller/fwupdate
@@ -26,7 +25,7 @@
 Section: admin
 Architecture: amd64 i386 armhf arm64 armel
 Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup0 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup0 (= ${binary:Version}), efibootmgr
 Description: Tools to manage UEFI firmware updates
  fwupdate provides functionality to update system firmware. It has been 
  initially designed to update firmware using UEFI capsule updates, but

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
EFIDIR ?= $(shell dpkg-vendor --query vendor | awk '{ print tolower($$0) }')

SB_PACKAGE :=
ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
SB_PACKAGE := 1
deb_version	:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
tar_name	:= fwupdate_$(deb_version)_$(DEB_HOST_ARCH).tar.gz
endif

buildroot	:= debian/tmp

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
			 libexecdir=\$${prefix}lib/ \
			 datadir=/var/cache/ \
			 localedir=/usr/share/locale/ \
			 GNUEFIDIR=\$${prefix}/lib \
			 EFIDIR=$(EFIDIR)
	sed 's,#EFIDIR#,$(EFIDIR),' \
		debian/fwupdate.postrm.in > debian/fwupdate.postrm

override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
			   libexecdir=\$${prefix}lib/ \
			   datadir=/var/cache/ \
			   localedir=/usr/share/locale/ \
			   GNUEFIDIR=\$${prefix}/lib \
			   EFIDIR=$(EFIDIR)
	chmod -x ${buildroot}/boot/efi/EFI/$(EFIDIR)/*.efi
	cp debian/scripts/install.in   ${buildroot}/usr/lib/fwupdate/install
	sed -i 's,#EFIDIR#,$(EFIDIR),' ${buildroot}/usr/lib/fwupdate/install

override_dh_clean:
	dh_clean
ifneq (,$(SB_PACKAGE))
		rm -rf debian/fwupdate-images
endif

override_dh_builddeb:
	dh_builddeb -- -Zxz
ifneq (,$(SB_PACKAGE))
		mkdir -p debian/fwupdate-images/$(deb_version)
		cp efi/fwup*.efi debian/fwupdate-images/$(deb_version)
		echo $(deb_version) \
			> debian/fwupdate-images/$(deb_version)/version
			cd debian/fwupdate-images && tar czvf ../../../$(tar_name) .
			dpkg-distaddfile $(tar_name) raw-uefi -
endif

## fwupdate 8

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,11 @@
+default : all
+
 TOPDIR=$(shell pwd)
 include $(TOPDIR)/Make.version
 include $(TOPDIR)/Make.defaults
 SUBDIRS = efi linux docs include
 
-all clean install :
+all clean install : | check_efidir_error
 	@set -e ; for x in $(SUBDIRS) ; do \
 		$(MAKE) DESTDIR=$(DESTDIR) TOPDIR=$(TOPDIR) VERSION=$(VERSION) \
 			LIBDIR=$(LIBDIR) bindir=$(bindir) mandir=$(mandir) \

=== efi/Makefile ===
--- 
+++ 
@@ -1,11 +1,13 @@
+default : all
+
 TOPDIR	?= $(shell pwd)/..
 include $(TOPDIR)/Make.version
 include $(TOPDIR)/Make.defaults
 
 CFLAGS		?= -O0 -g3
-BUILDFLAGS	:= $(CFLAGS) -fpic -Wall -fshort-wchar \
-	-fno-strict-aliasing -fno-merge-constants -ffreestanding \
-	-fno-stack-protector -fno-stack-check --std=c11 -DCONFIG_$(ARCH) \
+BUILDFLAGS	:= $(CFLAGS) -fpic -Werror -Wall -Wextra -fshort-wchar \
+	-fno-merge-constants -ffreestanding \
+	-fno-stack-protector -fno-stack-check --std=gnu11 -DCONFIG_$(ARCH) \
 	-I/usr/include/efi/ -I/usr/include/efi/$(ARCH)/ \
 	-iquote$(TOPDIR)/include "-DDEBUGDIR=L\"$(DEBUGDIR)/\""
 CCLDFLAGS	?= -nostdlib -Wl,--warn-common \
@@ -104,6 +106,7 @@
  ln -sf ../..$(TARGETDIR)$(1).debug $(DESTDIR)$(DEBUGINFO).build-id/$(shell cat $(1).build-id).debug
 endef
 
+install : | check_efidir_error
 install : $(FWUP).efi | $(FWUP).efi.debug $(FWUP).efi.build-id
 	$(INSTALL) -d -m 755 $(DESTDIR)$(TARGETDIR)/fw/
 	$(foreach prog,$^,$(call inst,$(prog)) ; )

=== include/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 include $(TOPDIR)/Make.version
 include $(TOPDIR)/Make.defaults
 
-all clean :
+all clean dep :
 
 install :
 	$(INSTALL) -d -m 755 $(DESTDIR)$(DEBUGSOURCE)fwupdate-$(VERSION)/include

=== linux/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+default : all
+
 TOPDIR	?= $(shell pwd)/..
 include $(TOPDIR)/Make.version
 include $(TOPDIR)/Make.defaults
@@ -5,6 +7,13 @@
 LIB_LIBS= pthread
 BIN_LIBS= popt pthread
 PKLIBS	= efivar efiboot
+HAVE_LIBSMBIOS=no
+ifeq ($(ARCH),x86_64)
+	HAVE_LIBSMBIOS=yes
+endif
+ifeq ($(ARCH),ia32)
+	HAVE_LIBSMBIOS=yes
+endif
 CFLAGS	?= -g -O0
 PJONES  =
 BIN_CCLDFLAGS = $(foreach lib,$(BIN_LIBS),-l$(lib)) \
@@ -16,7 +25,12 @@
 		$(shell pkg-config --libs-only-l --libs-only-other $(pklib))) \
 	$(LDFLAGS) -shared -fPIC -Wl,-z,relro,-z,now
 
-BUILDFLAGS := $(CFLAGS) -Wall -Wno-unused-result -Wno-unused-function \
+ifeq ($(HAVE_LIBSMBIOS),yes)
+	PKLIBS += libsmbios_c
+	CFLAGS += -DFWUPDATE_HAVE_LIBSMBIOS__
+endif
+BUILDFLAGS := $(CFLAGS) -Wall -Wextra -Werror -Wno-error=cpp \
+	-Wno-unused-result -Wno-unused-function \
 	-Wsign-compare -Werror=sign-compare \
 	-fshort-wchar --std=gnu11 \
 	-DLOCALEDIR=\"$(localedir)\" -D_GNU_SOURCE \
@@ -26,11 +40,11 @@
 	$(PJONES)
 
 BINTARGETS=fwupdate
-INCTARGETS=include/fwup.h
-LIBTARGETS=libfwup.so.$(VERSION) libfwup.so.$(MAJOR_VERSION)
+INCTARGETS=include/fwup-version.h include/fwup.h
+LIBTARGETS=libfwup.so
 PCTARGETS=fwup.pc
 POTARGETS = fwupdate.po libfwup.po
-TARGETS=$(BINTARGETS) $(INCTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) libfwup.so cleanup.service cleanup
+TARGETS=$(BINTARGETS) $(INCTARGETS) $(foreach x,$(LIBTARGETS),$(x) $(x).1 $(x).1.$(VERSION)) $(PCTARGETS) $(POTARGETS) libfwup.so cleanup.service cleanup
 
 .SUFFIXES:
 
@@ -38,18 +52,21 @@
 
 fwupdate : libfwup.so
 
+libfwup.c : | include/fwup.h include/fwup-version.h
+include/fwup.h : | include/fwup-version.h
+
 % : %.o
 	$(CC) $(BUILDFLAGS) -o $@ $(patsubst lib%.so,-l%,$^) $(BIN_CCLDFLAGS)
 
-%.so.$(VERSION) : %.o
+%.so.1.$(VERSION) : %.o
 	$(CC) $(BUILDFLAGS) \
-		-Wl,-soname,$(patsubst %.o,%.so.$(MAJOR_VERSION),$<) \
+		-Wl,-soname,$(patsubst %.o,%.so.1,$<) \
 		-o $@ $^ $(LIB_CCLDFLAGS)
 
-%.so.$(MAJOR_VERSION) : %.so.$(VERSION)
+%.so.1 : %.so.1.$(VERSION)
 	ln -sf $< $@
 
-%.so : %.so.$(VERSION)
+%.so : %.so.1.$(VERSION)
 	ln -sf $< $@
 
 %.po : %.c
@@ -60,6 +77,8 @@
 
 % : %.in
 	sed -e "s,@@VERSION@@,$(VERSION),g" \
+		-e "s,@@FWUP_MAJOR_VERSION@@,$(MAJOR_VERSION),g" \
+		-e "s,@@FWUP_MINOR_VERSION@@,$(MINOR_VERSION),g" \
 		-e "s,@@DATADIR@@,$(datadir),g" \
 		-e "s,@@EFIDIR@@,$(EFIDIR),g" \
 		-e "s,@@LIBDIR@@,$(libdir),g" \
@@ -77,10 +96,11 @@
 	@rm -vf $(BINTARGETS) $(LIBTARGETS) $(PCTARGETS) $(POTARGETS) *.o
 	@rm -vf libfwup.so*
 	@rm -vf cleanup.service cleanup
+	@rm -vf include/fwup-version.h
 
-install : all
+install : check_efidir_error all
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(libdir)
-	$(foreach x, $(LIBTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(libdir);)
+	$(foreach x, $(LIBTARGETS), $(INSTALL) -m 755 $(x).1.$(VERSION) $(DESTDIR)/$(libdir);)
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(pcdir)
 	$(foreach x, $(PCTARGETS), $(INSTALL) -m 644 $(x) $(DESTDIR)/$(pcdir) ;)
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(includedir)/
@@ -89,7 +109,10 @@
 	$(INSTALL) -m 644 $(POTARGETS) $(DESTDIR)/$(localedir)/en/
 	$(INSTALL) -d -m 755 $(DESTDIR)/$(bindir)
 	$(foreach x, $(BINTARGETS), $(INSTALL) -m 755 $(x) $(DESTDIR)/$(bindir);)
-	$(foreach x, $(wildcard *.so.$(VERSION)), ln -fs $(x) $(patsubst %.so.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x)); ln -fs $(x) $(patsubst %.so.$(VERSION),%.so.$(MAJOR_VERSION),$(DESTDIR)/$(libdir)/$(x));)
+	$(foreach x, $(wildcard *.so.1.$(VERSION)), \
+		ln -fs $(x) $(patsubst %.so.1.$(VERSION),%.so.1,$(DESTDIR)/$(libdir)/$(x)) ;\
+		ln -fs $(x) $(patsubst %.so.1.$(VERSION),%.so,$(DESTDIR)/$(libdir)/$(x)) ;\
+		)
 	$(INSTALL) -d -m 755 $(DESTDIR)$(datadir)/fwupdate/
 	$(INSTALL) -d -m 755 $(DESTDIR)$(libexecdir)/fwupdate/
 	$(INSTALL) -m 755 cleanup $(DESTDIR)$(libexecdir)/fwupdate/cleanup

=== debian/changelog ===
fwupdate (8-3) unstable; urgency=medium

  * Rebuild against libefivar-dev 30.
  * drop efivar version required patch.

 -- Mario Limonciello <mario.limonciello@dell.com>  Fri, 23 Sep 2016 11:24:59 -0500

fwupdate (8-2) unstable; urgency=medium

  * debian/control:
    - Update dell email addresses (_ -> .)
    - Only build depend on libsmbios-dev for x86 (Closes: #837198)
    - Drop armel from architecture list (no gnu-efi)

 -- Mario Limonciello <mario.limonciello@dell.com>  Wed, 07 Sep 2016 14:40:52 -0500

fwupdate (8-1) unstable; urgency=medium

  * New upstream version (8)
  * Add build-depends on libsmbios-dev and tighten libefivar-dev dependency
  * Correct various postinstall scripts for issues caught by shellcheck
  * Add a postinst for libfwup0 to satisfy lintian error about not calling
    ldconfig
  * more shellcheck improvements
  * Set EFIDIR on clean rule too
  * fix install command
  * Update to tighter efivar dependencies
  * Add patch to fix efivar version dependency
  * Update standards version.
  * drop empty libfwup1 postinstall script
  * Add lintian override for systemd missing Install target

 -- Mario Limonciello <mario_limonciello@dell.com>  Mon, 29 Aug 2016 09:30:32 -0500

fwupdate (0.5-4) unstable; urgency=medium

  * Force date to use UTC timezone for reproducible builds
  * Don't fail if ESP's fw directory doesn't exist during postrm (Closes: #810697)
  * Fix potential upgrades from older versions of fwupdate that didn't have an
    explicit dependency to bring in lsb_release
  * Cleanup fwupdate.postinst on clean step too

 -- Mario Limonciello <mario_limonciello@dell.com>  Fri, 15 Apr 2016 15:50:41 -0500

fwupdate (0.5-3) unstable; urgency=medium

  * Correct the location of the signed binaries
  * Remove immutable attribute in cleanup script due to a kernel behavioral
    change in ed8b0de5.
  * Correct one more path related to signed script
  * If EFI variables aren't available when the postinst runs, don't mistakingly
    mark the cleanup script as done.  This avoids the cleanup done flag being
    written in chroot situations
  * Create ESP directory from scripts/install instead
  * Purge EFI binaries from ESP for correct architecture
  * If system isn't running in EFI mode, don't install binary to ESP directory
  * Build DISTRIBUTOR into /usr/lib/fwupdate/install at build using dpkg-vendor.
  * Modify postrm script: hardcode EFIDIR at build time, use
    DPKG_MAINTSCRIPT_ARCH
  * Remove empty directories during fwupdate cleanup (Closes: #810697)
  * Make builds reproducible by setting POT-Creation-Date from debian/changelog.
  * Adjust fwupdate.postinst.in's upgrade part of the script to not use lsb_release as well
  * Drop dependency on coreutils, it's in Essential
  * Add comments explaining the situation with signed vs unsigned binaries to README.Debian
  * Fix a typo in debian/control

 -- Mario Limonciello <mario_limonciello@dell.com>  Mon, 28 Mar 2016 19:41:06 -0500

=== debian/control ===
Source: fwupdate
Priority: optional
Maintainer: Debian EFI <debian-efi@lists.debian.org>
Uploaders: Daniel Jared Dominguez <jared.dominguez@dell.com>, Steve McIntyre <93sam@debian.org>, Mario Limonciello <mario.limonciello@dell.com>
Build-Depends: debhelper (>= 9.0.0), pkg-config, libpopt-dev, libefivar-dev (>= 30), libefiboot-dev (>= 30), gnu-efi (>= 3.0.2), elfutils, libsmbios-dev [amd64 i386]
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/rhinstaller/fwupdate
Vcs-Git: git://anonscm.debian.org/uefi/fwupdate.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=uefi/fwupdate.git

Package: libfwup-dev
Section: libdevel
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Depends: libfwup1 (= ${binary:Version}), ${misc:Depends}, libefivar-dev (>= 0.16)
Description: Development headers for libfwup
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This package provides development headers required to use libfwup.

Package: fwupdate
Section: admin
Architecture: amd64 i386 armhf arm64
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, libfwup1 (= ${binary:Version}), efibootmgr
Description: Tools to manage UEFI firmware updates
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This package provides a simple command line interface to perform UEFI 
 firmware updates.

Package: libfwup1
Architecture: amd64 i386 armhf arm64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to manage UEFI firmware updates
 fwupdate provides functionality to update system firmware. It has been 
 initially designed to update firmware using UEFI capsule updates, but 
 it is designed to be extensible to other firmware update standards.
 .
 This library is to allow for the simple manipulation of UEFI firmware updates.

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 EFIDIR ?= $(shell dpkg-vendor --query vendor | awk '{ print tolower($$0) }')
+PODATE := $(shell dpkg-parsechangelog --show-field Date | xargs -0 date --utc "+%Y-%m-%d %H:%M%z" --date)
 
 SB_PACKAGE :=
 ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
@@ -12,6 +12,7 @@
 endif
 
 buildroot	:= debian/tmp
+
 
 %:
 	dh $@
@@ -25,6 +26,14 @@
 			 EFIDIR=$(EFIDIR)
 	sed 's,#EFIDIR#,$(EFIDIR),' \
 		debian/fwupdate.postrm.in > debian/fwupdate.postrm
+	sed 's,#EFIDIR#,$(EFIDIR),' \
+		debian/fwupdate.postinst.in > debian/fwupdate.postinst
+
+	# This is to satisfy https://wiki.debian.org/ReproducibleBuilds
+	sed -i 's,POT-Creation-Date:.*,POT-Creation-Date: $(PODATE)\\n",' \
+		linux/libfwup.po
+	sed -i 's,POT-Creation-Date:.*,POT-Creation-Date: $(PODATE)\\n",' \
+		linux/fwupdate.po
 
 override_dh_auto_install:
 	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
@@ -37,8 +46,8 @@
 	cp debian/scripts/install.in   ${buildroot}/usr/lib/fwupdate/install
 	sed -i 's,#EFIDIR#,$(EFIDIR),' ${buildroot}/usr/lib/fwupdate/install
 
-override_dh_clean:
-	dh_clean
+override_dh_auto_clean:
+	dh_auto_clean -- EFIDIR=$(EFIDIR)
 ifneq (,$(SB_PACKAGE))
 		rm -rf debian/fwupdate-images
 endif
